unit timeSpeakUnit;

interface

uses
  Classes, sysUtils, forms, mmSystem;

var
  files: array of string;
  messageHandle: tHandle;
  userValue: integer;
  path: string;

procedure say(const hours, minutes: word);

implementation

uses timeSpeakThread;

procedure say(const hours, minutes: word);
var
min, hour: string[2];
end1, end2: string[2];
begin
   if minutes = 0 then
   begin
      setLength(files, 1);
      files[0] := 'rovno';
   end
   else
   begin
      min := intToStr(minutes);
      end1 := ''; end2 := '';
      if minutes < 10 then
      begin
         case minutes of
         1: begin end1 := 'a'; end2 := 'a'; end;
         2: begin end1 := 'e'; end2 := 'i'; end;
         3, 4: end2 := 'i';
         end;
         setLength(files, 2);
         files[1] := min+end1;
         files[0] := 'minut'+end2;
      end
      else
      begin
         if (minutes < 20) or (min[2] = '0') then
         begin
            setLength(files, 2);
            files[1] := min;
            files[0] := 'minut';
         end
         else
         begin
            case strToInt(min[2]) of
            1: begin end1 := 'a'; end2 := 'a'; end;
            2: begin end1 := 'e'; end2 := 'i'; end;
            3, 4: end2 := 'i';
            end;
            setLength(files, 3);
            files[2] := min[1]+'0';
            files[1] := min[2]+end1;
            files[0] := 'minut'+end2;
         end;
      end;
   end;
   hour := intToStr(hours);

   end2 := 'ov';
   case hours of
   1, 21: end2 := '';
   2, 3, 4, 22, 23: end2 := 'a';
   end;

   setLength(files, high(files)+3);
   files[high(files)] := hour;
   files[high(files)-1] := 'chas'+end2;
end;


end.
