﻿unit utils;

interface

uses
  Windows, Forms, Messages, SysUtils, Dialogs, Variants, Classes,
  Graphics, Controls, ComCtrls, ExtCtrls,
  ActnList, ActnMan, ImgList, MPlayer, XPStyleActnCtrls, StdCtrls,
  Menus, ActnPopup, Buttons, Spin, pngextra, popUp;

type
  Tutils_form = class(TForm)
    pages: TPageControl;
    alarm_page: TTabSheet;
    alarm_list: TListView;
    ctrl_panel1: TPanel;
    timer_page: TTabSheet;
    ctrl_panel2: TPanel;
    secmer_page: TTabSheet;
    ctrl_panel3: TPanel;
    main_actions: TActionManager;
    timer_list: TListView;
    secMer_list: TListView;
    player: TMediaPlayer;
    settings_page: TTabSheet;
    alarm_edit_button: TPNGButton;
    alarm_del_button: TPNGButton;
    del_all_alarms_button: TPNGButton;
    alarm_add_button: TPNGButton;
    alarm_active_button: TSpeedButton;
    timer_add_button: TPNGButton;
    timer_edit_button: TPNGButton;
    timer_del_button: TPNGButton;
    del_all_timers_button: TPNGButton;
    timer_active_button: TSpeedButton;
    timer_reset_button: TSpeedButton;
    secMer_edit_button: TPNGButton;
    secMer_del_button: TPNGButton;
    del_all_secmers_button: TPNGButton;
    secMer_reset_button: TSpeedButton;
    secMer_active_button: TSpeedButton;
    secMer_add_button: TPNGButton;
    a_allUnActive: TAction;
    a_allActive: TAction;
    s_allActive: TAction;
    s_allUnActive: TAction;
    t_allActive: TAction;
    t_allUnActive: TAction;
    a_menu_button: TSpeedButton;
    a_popup: TPopupMenu;
    t_popup: TPopupMenu;
    s_popup: TPopupMenu;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    t_menu_button: TSpeedButton;
    s_menu_button: TSpeedButton;
    ScrollBox1: TScrollBox;
    Bevel2: TBevel;
    s5_btn: TRadioButton;
    s4_btn: TRadioButton;
    Label5: TLabel;
    Bevel1: TBevel;
    s3_btn: TRadioButton;
    s2_btn: TCheckBox;
    Label1: TLabel;
    _alarmAdd: TMenuItem;
    _alarmEdit: TMenuItem;
    _alarmDel: TMenuItem;
    _alarmDelAll: TMenuItem;
    N11: TMenuItem;
    _alarmActive: TMenuItem;
    _alarmShowInfo: TMenuItem;
    _secMerAdd: TMenuItem;
    _secMerEdit: TMenuItem;
    _secMerDel: TMenuItem;
    _secMerDelAll: TMenuItem;
    N18: TMenuItem;
    _secMerActive: TMenuItem;
    _secMerShowInfo: TMenuItem;
    _timerAdd: TMenuItem;
    _timerEdit: TMenuItem;
    _timerDel: TMenuItem;
    _timerDelAll: TMenuItem;
    N25: TMenuItem;
    _timerActive: TMenuItem;
    _timerShowInfo: TMenuItem;
    _timerReset: TMenuItem;
    _secMerReset: TMenuItem;
    Label2: TLabel;
    s6_btn: TCheckBox;
    s7_edit: TSpinEdit;
    Label3: TLabel;
    s1_btn: TCheckBox;
    s8_edit: TComboBox;
    Label4: TLabel;
    Label6: TLabel;
    s10_edit: TSpinEdit;
    Label7: TLabel;
    s9_edit: TSpinEdit;
    s_selectedActive: TAction;
    s_selectedUnActive: TAction;
    N30: TMenuItem;
    N31: TMenuItem;
    N32: TMenuItem;
    N33: TMenuItem;
    t_selectedActive: TAction;
    t_selectedUnActive: TAction;
    N34: TMenuItem;
    N35: TMenuItem;
    N36: TMenuItem;
    N37: TMenuItem;
    a_selectedActive: TAction;
    a_selectedUnActive: TAction;
    N38: TMenuItem;
    N39: TMenuItem;
    N40: TMenuItem;
    N41: TMenuItem;
    N42: TMenuItem;
    N43: TMenuItem;
    s20_btn: TCheckBox;
    Label8: TLabel;
    s21_edit: TSpinEdit;
    Label9: TLabel;
    Label10: TLabel;
    s22_edit: TPanel;
    Bevel3: TBevel;
    Label11: TLabel;
    s11_btn: TCheckBox;
    s12_edit: TComboBox;
    s15_edit: TComboBox;
    s14_btn: TCheckBox;
    s18_edit: TComboBox;
    s17_btn: TCheckBox;
    Bevel4: TBevel;
    t_selectActive: TAction;
    t_selectUnActive: TAction;
    t_selectAll: TAction;
    N1: TMenuItem;
    N2: TMenuItem;
    N44: TMenuItem;
    N45: TMenuItem;
    N46: TMenuItem;
    a_selectActive: TAction;
    a_selectUnActive: TAction;
    a_selectAll: TAction;
    N47: TMenuItem;
    N48: TMenuItem;
    N49: TMenuItem;
    N50: TMenuItem;
    N51: TMenuItem;
    s_selectActive: TAction;
    s_selectUnActive: TAction;
    s_selectAll: TAction;
    N52: TMenuItem;
    N53: TMenuItem;
    N54: TMenuItem;
    N55: TMenuItem;
    N56: TMenuItem;
    a_selectToday: TAction;
    N57: TMenuItem;
    a_selectInvert: TAction;
    N58: TMenuItem;
    t_selectInvert: TAction;
    N59: TMenuItem;
    s_selectInvert: TAction;
    N60: TMenuItem;
    Label12: TLabel;
    Label13: TLabel;
    s23_edit: TPanel;
    Label14: TLabel;
    s24_edit: TPanel;
    Label15: TLabel;
    s25_edit: TPanel;
    s26_edit: TPanel;
    Label16: TLabel;
    s13_edit: TComboBox;
    Label17: TLabel;
    s16_edit: TComboBox;
    Label18: TLabel;
    s19_edit: TComboBox;
    Label19: TLabel;
    Bevel5: TBevel;
    Label20: TLabel;
    s27_btn: TCheckBox;
    showCalendar_button: TPNGButton;
    s28_btn: TCheckBox;
    groupShow_button: TPNGButton;
    _moveIntoGroup: TMenuItem;
    Status_Bar: TStatusBar;
    a_groups: TAction;
    _showGroups: TMenuItem;
    a_calendar: TAction;
    _showCalendar: TMenuItem;
    add: TAction;
    del: TAction;
    edit: TAction;
    delAll: TAction;
    active: TAction;
    reset: TAction;
    showCalendar: TAction;
    showGroups: TAction;
    showInfo: TAction;
    _gotoAlarms: TAction;
    _gotoTimer: TAction;
    _gotoSecMer: TAction;
    _gotoConfigs: TAction;
    _next: TAction;
    _previous: TAction;
    _close: TAction;
    _onEnter: TAction;
    _savePorameters: TAction;
    _loadPoramiters: TAction;
    _selectAll: TAction;
    Action1: TAction;
    s29_btn: TCheckBox;
    s30_btn: TCheckBox;
    s31_btn: TCheckBox;
    s32_btn: TCheckBox;
    procedure Action1Execute(Sender: TObject);
    procedure _selectAllExecute(Sender: TObject);
    procedure _loadPoramitersExecute(Sender: TObject);
    procedure _savePorametersExecute(Sender: TObject);
    procedure _onEnterExecute(Sender: TObject);
    procedure _closeExecute(Sender: TObject);
    procedure _previousExecute(Sender: TObject);
    procedure _nextExecute(Sender: TObject);
    procedure gotoPage(Sender: TObject);
    procedure showInfoExecute(Sender: TObject);
    procedure showGroupsExecute(Sender: TObject);
    procedure showCalendarExecute(Sender: TObject);
    procedure resetExecute(Sender: TObject);
    procedure activeExecute(Sender: TObject);
    procedure delAllExecute(Sender: TObject);
    procedure editExecute(Sender: TObject);
    procedure delExecute(Sender: TObject);
    procedure addExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure pagesChange(Sender: TObject);
    procedure ScrollBox1MouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure ScrollBox1MouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure hintHide(Sender: TObject);
    procedure hintShow(Sender: TObject);
    procedure groupShow_buttonClick(Sender: TObject);
    procedure showCalendar_buttonClick(Sender: TObject);
    procedure s_selectInvertExecute(Sender: TObject);
    procedure t_selectInvertExecute(Sender: TObject);
    procedure a_selectInvertExecute(Sender: TObject);
    procedure a_selectTodayExecute(Sender: TObject);
    procedure secMer_listCustomDrawItem(Sender: TCustomListView;
      Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure timer_listCustomDrawItem(Sender: TCustomListView; Item: TListItem;
      State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure alarm_listCustomDrawItem(Sender: TCustomListView; Item: TListItem;
      State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure s_selectAllExecute(Sender: TObject);
    procedure s_selectUnActiveExecute(Sender: TObject);
    procedure s_selectActiveExecute(Sender: TObject);
    procedure t_selectAllExecute(Sender: TObject);
    procedure t_selectUnActiveExecute(Sender: TObject);
    procedure t_selectActiveExecute(Sender: TObject);
    procedure a_selectAllExecute(Sender: TObject);
    procedure a_selectUnActiveExecute(Sender: TObject);
    procedure a_selectActiveExecute(Sender: TObject);
    procedure selectColor(Sender: TObject);
    procedure s20_btnClick(Sender: TObject);
    procedure s17_btnClick(Sender: TObject);
    procedure s14_btnClick(Sender: TObject);
    procedure s11_btnClick(Sender: TObject);
    procedure a_selectedUnActiveExecute(Sender: TObject);
    procedure a_selectedActiveExecute(Sender: TObject);
    procedure alarm_active_buttonClick(Sender: TObject);
    procedure timer_active_buttonClick(Sender: TObject);
    procedure t_selectedUnActiveExecute(Sender: TObject);
    procedure t_selectedActiveExecute(Sender: TObject);
    procedure s_selectedUnActiveExecute(Sender: TObject);
    procedure secMer_active_buttonClick(Sender: TObject);
    procedure s_selectedActiveExecute(Sender: TObject);
    procedure s8_editChange(Sender: TObject);
    procedure s6_btnClick(Sender: TObject);
    procedure t_showinfoExecute(Sender: TObject);
    procedure s_showinfoExecute(Sender: TObject);
    procedure a_showinfoExecute(Sender: TObject);
    procedure s_menu_buttonClick(Sender: TObject);
    procedure t_menu_buttonClick(Sender: TObject);
    procedure a_menu_buttonClick(Sender: TObject);
    procedure t_allUnActiveExecute(Sender: TObject);
    procedure t_allActiveExecute(Sender: TObject);
    procedure s_allUnActiveExecute(Sender: TObject);
    procedure s_allActiveExecute(Sender: TObject);
    procedure a_allUnActiveExecute(Sender: TObject);
    procedure a_allActiveExecute(Sender: TObject);
    procedure secMer_listDblClick(Sender: TObject);
    procedure secMer_listSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure s_resetExecute(Sender: TObject);
    procedure s_activeExecute(Sender: TObject);
    procedure s_editExecute(Sender: TObject);
    procedure s_del_allExecute(Sender: TObject);
    procedure s_delExecute(Sender: TObject);
    procedure s_addExecute(Sender: TObject);
    procedure t_resetExecute(Sender: TObject);
    procedure t_activeExecute(Sender: TObject);
    procedure t_editExecute(Sender: TObject);
    procedure t_del_allExecute(Sender: TObject);
    procedure timer_listSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure timer_listDblClick(Sender: TObject);
    procedure t_delExecute(Sender: TObject);
    procedure t_addExecute(Sender: TObject);
    procedure alarm_listDblClick(Sender: TObject);
    procedure alarm_listSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure a_activeExecute(Sender: TObject);
    procedure a_editExecute(Sender: TObject);
    procedure a_del_allExecute(Sender: TObject);
    procedure a_delExecute(Sender: TObject);
    procedure a_addExecute(Sender: TObject);
  private
    { Private declarations }
    procedure speakEnd(var msg: tMessage); message WM_USER+1;
  public
    { Public declarations }
  end;

var
  utils_form: Tutils_form;

implementation

uses global_vars, ats, timer_utils, alarm_utils, secMer_utils, soundPlay,
  dateUtils, calendar, calendarEdit, groupEdit, save_load_settings;

{$R *.dfm}

procedure Tutils_form.Action1Execute(Sender: TObject);
var
c: smallInt;
begin
   {if high(Alarms) < 0 then exit;
   for c := 0 to high(Alarms) do
   if alarms[c].selected and (not groups[alarms[c].groupIndex].visible) then
   showMessage(intToStr(c));}
end;

procedure Tutils_form.activeExecute(Sender: TObject);
begin
   if groupEdit_form.groupView.focused then
   begin
      groupEdit_form.visible_button.Down :=
      not groupEdit_form.visible_button.Down;
      groupEdit_form.visible_button.OnClick(nil);
      exit;
   end;

   case pages.ActivePageIndex of
   0: begin _alarmactive.checked := not _alarmactive.Checked; a_activeexecute(nil); end;
   1: begin _timeractive.checked := not _timeractive.Checked; t_activeexecute(nil); end;
   2: begin _secMeractive.checked := not _secMeractive.Checked; s_activeexecute(nil); end;
   end;
end;

procedure Tutils_form.addExecute(Sender: TObject);
begin
   if groupEdit_form.groupView.focused then
   begin
      groupEdit_form.add_button.OnClick(nil);
      exit;
   end;

   case pages.ActivePageIndex of
   0: a_addexecute(nil);
   1: t_addexecute(nil);
   2: s_addexecute(nil);
   end;
end;

procedure Tutils_form.alarm_active_buttonClick(Sender: TObject);
var
c: smallInt;
begin
   if alarm.areAnySelected = 0 then exit;

   for c := 0 to high(alarms) do
     if alarms[c].selected then
     alarm.setActive(c, alarm_active_button.Down);
end;

procedure Tutils_form.alarm_listCustomDrawItem(Sender: TCustomListView;
  Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
var
fontColor: integer;
procedure onesInDayTest;
begin
   if alarms[alarmIndexes[item.Index]].onesInDay then
   begin
      if (dateOf(alarms[alarmIndexes[item.Index]].rang_in) <> date) then
      if alarms[alarmIndexes[item.Index]].useSpace then
      begin
         if (hourOf(time) <= alarms[alarmIndexes[item.Index]].activeTo) then
         fontColor := s25_edit.Color;
      end
      else fontColor := s25_edit.Color;
   end
   else
   begin
      if alarms[alarmIndexes[item.Index]].useSpace then
      begin
         if (hourOf(time) <= alarms[alarmIndexes[item.Index]].activeTo) then
         fontColor := s25_edit.Color;
      end
      else fontColor := s25_edit.Color;
   end;
end;
begin
   if alarms[alarmIndexes[item.Index]].active then
      alarm.listView.Canvas.Brush.Color := s23_edit.Color
   else
      alarm.listView.Canvas.Brush.Color := s24_edit.Color;

   fontColor := clWindowText;

   if not alarms[alarmIndexes[item.Index]].onAppRun then
   { если по времени }
     case alarms[alarmIndexes[item.Index]].mode of
     0:
     begin
        if (dateOf(alarms[alarmIndexes[item.Index]].set_on) = date) and
           (timeOf(alarms[alarmIndexes[item.Index]].set_on) > time) then
           fontColor := s25_edit.Color;

        if alarms[alarmIndexes[item.Index]].set_on < time + date then
          fontColor := s26_edit.Color;
     end;
     1:
     begin
        if alarms[alarmIndexes[item.Index]].days[dayOfWeek(date)] and
          (timeOf(alarms[alarmIndexes[item.Index]].set_on) > time) then
          fontColor := s25_edit.Color;
     end;
     2:
     begin
        if (dayOf(alarms[alarmIndexes[item.Index]].set_on) = dayOf(date)) and
           (timeOf(alarms[alarmIndexes[item.Index]].set_on) > time) then
           fontColor := s25_edit.Color;
     end;
     3:
     begin
        if (dayOf(alarms[alarmIndexes[item.Index]].set_on) = dayOf(date)) and
           (monthOf(alarms[alarmIndexes[item.Index]].set_on) = monthOf(date)) and
           (timeOf(alarms[alarmIndexes[item.Index]].set_on) > time) then
           fontColor := s25_edit.Color;
     end;
     end
   else
   { если по запуску проги }
   case alarms[alarmIndexes[item.Index]].mode of
     0:
     begin
        if (dateOf(alarms[alarmIndexes[item.Index]].set_on) = date) then
          if alarms[alarmIndexes[item.Index]].onesInDay then
          begin
            if (dateOf(alarms[alarmIndexes[item.Index]].rang_in) = date) then
              fontColor := s26_edit.Color
            else
              if alarms[alarmIndexes[item.Index]].useSpace then
              begin
                if (hourOf(time) <= alarms[alarmIndexes[item.Index]].activeTo) then
                  fontColor := s25_edit.Color
                else
                  fontColor := s26_edit.Color;
              end
              else fontColor := s25_edit.Color;
          end
          else
          begin
             if alarms[alarmIndexes[item.Index]].useSpace then
              begin
                if (hourOf(time) <= alarms[alarmIndexes[item.Index]].activeTo) then
                  fontColor := s25_edit.Color
                else
                  fontColor := s26_edit.Color;
              end
              else fontColor := s25_edit.Color;
          end;

          if date > dateOf(alarms[alarmIndexes[item.Index]].set_on) then
            fontColor := s26_edit.Color;
     end;
     1:
     begin
        if alarms[alarmIndexes[item.Index]].days[dayOfWeek(date)] then
          onesInDayTest;
     end;
     2:
     begin
        if (dayOf(alarms[alarmIndexes[item.Index]].set_on) = dayOf(date)) then
          onesInDayTest;
     end;
     3:
     begin
        if (dayOf(alarms[alarmIndexes[item.Index]].set_on) = dayOf(date)) and
          (monthOf(alarms[alarmIndexes[item.Index]].set_on) = monthOf(date)) then
            onesInDayTest;
     end;
     end;

   alarm.listView.Canvas.Font.Color := fontColor;

   if item.Selected then
      alarm.listView.Canvas.Font.Style :=
      alarm.listView.Canvas.Font.Style + [fsBold];
end;

procedure Tutils_form.alarm_listDblClick(Sender: TObject);
var
c: smallInt;
begin
   if alarm.areAnySelected = 0 then exit;

   for c := 0 to high(alarms) do
     if alarms[c].selected then
     begin
        if utils_form.s3_btn.checked then alarm.showInfo(c);
        if utils_form.s4_btn.checked then alarm.edit(c);
        if utils_form.s5_btn.checked then a_delExecute(sender);
        exit;
     end;
end;

procedure Tutils_form.alarm_listSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
   alarm.listSelect(item.Index, selected); 
end;

procedure Tutils_form.a_activeExecute(Sender: TObject);
var
c: smallInt;
begin
   if alarm.areAnySelected = 0 then exit;

   for c := 0 to high(alarms) do
     if alarms[c].selected then
     alarm.setActive(c, _alarmactive.Checked);

   {if al_select_index >= 0 then
      alarm.setActive(al_select_index, a_active.Checked);}
end;

procedure Tutils_form.a_addExecute(Sender: TObject);
begin
   alarm.add;
end;

procedure Tutils_form.a_allActiveExecute(Sender: TObject);
begin
   alarm.setAllActive(true);
end;

procedure Tutils_form.a_allUnActiveExecute(Sender: TObject);
begin
   alarm.setAllActive(false);
end;

procedure Tutils_form.a_delExecute(Sender: TObject);
var
c, lastDeleted: smallInt;
haveToDel: array of smallInt;
begin
   if alarm.areAnySelected = 0 then exit;

   if utils_form.s2_btn.Checked then
   begin
      for c := 0 to high(alarms) do
      alarms[c].editing := alarms[c].selected;

      alarm.listCreate;

      if messageDlg('Вы действительно хотите удалить выбранные Будильники?',
       mtConfirmation, mbYesNo, 0) <> mrYes then
      begin
         for c := 0 to high(alarms) do
         alarms[c].editing := false;

         alarm.listCreate;
         exit;
      end;
   end;

   for c := 0 to high(alarms) do
   begin
      if alarms[c].selected then
      begin
         setLength(haveToDel, high(haveToDel)+2);
         haveToDel[high(haveToDel)] := c;
      end;
   end;

   lastDeleted := alarms[haveToDel[0]].itemIndex;

   for c := high(haveToDel) downto 0 do
      alarm.onlyDel(haveToDel[c]);

   alarm.selectAfterDel(lastDeleted);
end;

procedure Tutils_form.a_del_allExecute(Sender: TObject);
begin
   if high(alarms) < 0 then exit;
   if utils_form.s28_btn.Checked then
   begin
      if utils_form.s2_btn.checked then
         if messageDlg('Вы действительно хотите удалить все отображаемые будильники?',
         mtConfirmation, mbYesNo, 0) <> mrYes then exit;
      alarm.delAll(true);
   end
   else
   begin
      if utils_form.s2_btn.checked then
         if messageDlg('Вы действительно хотите удалить все будильники?',
         mtConfirmation, mbYesNo, 0) <> mrYes then exit;
      alarm.delAll;
   end;
end;

procedure Tutils_form.a_editExecute(Sender: TObject);
begin
   if alarm.areAnySelected = 0 then exit;
   alarm.edit(al_first_selected);
end;

procedure Tutils_form.a_selectActiveExecute(Sender: TObject);
var
c: smallInt;
//multiNotPress: Boolean;
begin
   //if high(alarms) < 0 then exit;

   if alarm.listView.Items.Count = 0 then exit;
   //multiNotPress := getasynckeystate(mSelectKey) = 0;

   {for c := 0 to high(alarms) do
     if alarms[c].active and groups[alarms[c].groupIndex].visible then
       alarm.listView.Items[alarms[c].itemIndex].Selected := true
     else
       if multiNotPress then alarm.listView.Items[alarms[c].itemIndex].Selected := false;}

   for c := 0 to alarm.listView.Items.Count - 1 do
     if alarms[alarmIndexes[c]].active then
        alarm.listView.Items[c].Selected := true
     else
        if not ctrlPress then alarm.listView.Items[c].Selected := false;

   try
      alarm.listView.SetFocus;
   except

   end;
end;

procedure Tutils_form.a_selectAllExecute(Sender: TObject);
var
c: smallInt;
begin
   {if high(alarms) < 0 then exit;
   for c := 0 to high(alarms) do
     alarm.listView.Items[c].Selected := true;}
   //////
   if alarm.listView.Items.Count = 0 then exit;
   for c := 0 to alarm.listView.Items.Count - 1 do
     alarm.listView.Items[c].Selected := true;
end;

procedure Tutils_form.a_selectedActiveExecute(Sender: TObject);
var
c: smallInt;
begin
   if high(alarms) < 0 then exit;
   for c := 0 to high(alarms) do
     if alarms[c].selected then alarm.setActive(c, true);
end;

procedure Tutils_form.a_selectedUnActiveExecute(Sender: TObject);
var
c: smallInt;
begin
   if high(alarms) < 0 then exit;
   for c := 0 to high(alarms) do
     if alarms[c].selected then alarm.setActive(c, false);
end;

procedure Tutils_form.a_selectInvertExecute(Sender: TObject);
var
c: smallInt;
begin
   {if high(alarms) < 0 then exit;
   for c := 0 to high(alarms) do
        alarm.listView.Items[c].Selected := not alarms[c].selected;}

   if alarm.listView.Items.Count = 0 then exit;
   for c := 0 to alarm.listView.Items.Count - 1 do
     alarm.listView.Items[c].Selected := not alarms[alarmIndexes[c]].selected;
end;

procedure Tutils_form.a_selectTodayExecute(Sender: TObject);
begin
   alarm.selectDate(today);
end;
procedure Tutils_form.a_selectUnActiveExecute(Sender: TObject);
var
c: smallInt;
//multiNotPress: Boolean;
begin
   //if high(alarms) < 0 then exit;

   if alarm.listView.Items.Count = 0 then exit;
   //multiNotPress := getasynckeystate(mSelectKey) = 0;

   {for c := 0 to high(alarms) do
     if not alarms[c].active and groups[alarms[c].groupIndex].visible then
       alarm.listView.Items[alarms[c].itemIndex].Selected := true
     else
       if multiNotPress then alarm.listView.Items[alarms[c].itemIndex].Selected := false;}

   for c := 0 to alarm.listView.Items.Count - 1 do
     if not alarms[alarmIndexes[c]].active then
        alarm.listView.Items[c].Selected := true
     else
        if not ctrlPress then alarm.listView.Items[c].Selected := false;

   try
      alarm.listView.SetFocus;
   except

   end;
end;

procedure Tutils_form.a_showinfoExecute(Sender: TObject);
begin
   if alarm.areAnySelected > 0 then
   alarm.showInfo(al_first_Selected);
end;

procedure Tutils_form.delAllExecute(Sender: TObject);
begin
   if groupEdit_form.groupView.focused then
   begin
      groupEdit_form.del_All_button.OnClick(nil);
      exit;
   end;

   case pages.ActivePageIndex of
   0: a_del_Allexecute(nil);
   1: t_del_allexecute(nil);
   2: s_del_allexecute(nil);
   end;
end;

procedure Tutils_form.delExecute(Sender: TObject);
begin
   if groupEdit_form.groupView.focused then
   begin
      groupEdit_form.del_button.OnClick(nil);
      exit;
   end;

   case pages.ActivePageIndex of
   0: a_delexecute(nil);
   1: t_delexecute(nil);
   2: s_delexecute(nil);
   end;
end;

procedure Tutils_form.editExecute(Sender: TObject);
begin
   if groupEdit_form.groupView.focused then
   begin
      groupEdit_form.edit_button.OnClick(nil);
      exit;
   end;

   case pages.ActivePageIndex of
   0: a_editexecute(nil);
   1: t_editexecute(nil);
   2: s_editexecute(nil);
   end;
end;

procedure Tutils_form.FormShow(Sender: TObject);
begin
   case pages.ActivePageindex of
   0: alarm_list.SetFocus;
   1: timer_list.SetFocus;
   2: secMer_list.SetFocus;
   3: s1_btn.SetFocus;
   end;
end;

procedure Tutils_form.gotoPage(Sender: TObject);
begin
   pages.ActivePageIndex := taction(sender).Tag;
end;

procedure Tutils_form.groupShow_buttonClick(Sender: TObject);
begin
   //groupEdit_form.close;

   if IsWindowVisible(groupEdit_form.handle) then
   begin
      groupEdit_form.setFocus;
      exit;
   end;

   groupEdit_form.Left := alarm_page.Width div 2 - groupEdit_form.Width div 2;
   groupEdit_form.Top := alarm_page.Height div 2 - groupEdit_form.Height div 2;


   pages.ActivePageIndex := 0;
   groupEdit_form.Parent := alarm_page;
   groupEdit_form.Show;
   groupEdit_form.SetFocus;
end;

procedure Tutils_form.hintHide(Sender: TObject);
begin
   status_bar.Panels[0].Text := statusBarCaption;
end;

procedure Tutils_form.hintShow(Sender: TObject);
begin
   status_bar.Panels[0].Text := tControl(sender).Hint;
end;

procedure Tutils_form.pagesChange(Sender: TObject);
begin
   statusBarCaption := '';
   status_bar.Panels[0].Text := pages.Pages[pages.ActivePageindex].Caption;

   {case pages.ActivePageindex of
   0: alarm_list.SetFocus;
   1: timer_list.SetFocus;
   2: secMer_list.SetFocus;   
   3: s1_btn.SetFocus;
   end;}
end;

procedure Tutils_form.resetExecute(Sender: TObject);
begin
   if groupEdit_form.groupView.focused then
   begin
      //groupEdit_form.add_button.OnClick(nil);
      exit;
   end;

   case pages.ActivePageIndex of
   //0: a_addexecute(nil);
   1: t_resetexecute(nil);
   2: s_resetexecute(nil);
   end;
end;

procedure Tutils_form.s11_btnClick(Sender: TObject);
begin
   s12_edit.Enabled := s11_btn.Checked;
   s13_edit.Enabled := s11_btn.Checked;
   label17.Enabled := s11_btn.Checked;
end;

procedure Tutils_form.s14_btnClick(Sender: TObject);
begin
   s15_edit.Enabled := s14_btn.Checked;
   s16_edit.Enabled := s14_btn.Checked;
   label18.Enabled := s14_btn.Checked;
end;

procedure Tutils_form.s17_btnClick(Sender: TObject);
begin
   s18_edit.Enabled := s17_btn.Checked;
   s19_edit.Enabled := s17_btn.Checked;
   label19.Enabled := s17_btn.Checked;
end;

procedure Tutils_form.s20_btnClick(Sender: TObject);
var
value: boolean;
begin
   value := s20_btn.Checked;
   label8.Enabled := value;
   label9.Enabled := value;
   label10.Enabled := value;

   s21_edit.Enabled := value;
   s22_edit.Enabled := value;
end;

procedure Tutils_form.selectColor(Sender: TObject);
var
cd: tColorDialog;
begin
   cd := tColorDialog.Create(self);
   cd.Color := tPanel(sender).Color;
   if not cd.Execute then exit;
      tPanel(sender).Color := cd.Color;
   cd.Free;
end;

procedure Tutils_form.showCalendarExecute(Sender: TObject);
begin
   //utils_form.Close;
   //utils_form.Show;
   utils_form.pages.ActivePageIndex := 0;
   utils_form.showCalendar_buttonClick(nil);
end;

procedure Tutils_form.showCalendar_buttonClick(Sender: TObject);
begin
   //calendarEdit_form.close;
   if IsWindowVisible(calendarEdit_form.handle) then
   begin
      calendarEdit_form.setFocus;
      exit;
   end;

   calendarEdit_form.Left := alarm_page.Width div 2 - calendarEdit_form.Width div 2;
   calendarEdit_form.Top := alarm_page.Height div 2 - calendarEdit_form.Height div 2;

   pages.ActivePageIndex := 0;
   calendarEdit_form.Parent := alarm_page;

   calendarEdit_form.Show;
   calendarEdit_form.SetFocus;
end;

procedure Tutils_form.showGroupsExecute(Sender: TObject);
begin
   utils_form.pages.ActivePageIndex := 0;
   utils_form.groupShow_buttonClick(nil);
end;

procedure Tutils_form.showInfoExecute(Sender: TObject);
begin
   if groupEdit_form.groupView.focused then
   begin
      //groupEdit_form.del_All_button.OnClick(nil);
      exit;
   end;

   case pages.ActivePageIndex of
   0: a_showInfoexecute(nil);
   1: t_showInfoexecute(nil);
   2: s_showInfoexecute(nil);
   end;
end;

procedure Tutils_form.s6_btnClick(Sender: TObject);
begin
   s7_edit.Enabled := s6_btn.Checked;
end;

procedure Tutils_form.s8_editChange(Sender: TObject);
begin
   s9_edit.Enabled := s8_edit.ItemIndex >= 5;
   s10_edit.Enabled := s8_edit.ItemIndex >= 5;
   label6.Enabled := s8_edit.ItemIndex >= 5;
   label7.Enabled := s8_edit.ItemIndex >= 5;
end;

procedure Tutils_form.ScrollBox1MouseWheelDown(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
begin
   with scrollBox1.VertScrollBar do
   Position := Position + Increment;
end;

procedure Tutils_form.ScrollBox1MouseWheelUp(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
begin
   with scrollBox1.VertScrollBar do
   Position := Position - Increment;
end;

procedure Tutils_form.secMer_active_buttonClick(Sender: TObject);
var
c: smallInt;
begin
   if secMer.areAnySelected = 0 then exit;

   for c := 0 to high(secMers) do
     if secMers[c].selected then
     secMer.setActive(c, secMer_active_button.down);

   {if al_select_index >= 0 then
      alarm.setActive(al_select_index, a_active.Checked);}
end;

procedure Tutils_form.secMer_listCustomDrawItem(Sender: TCustomListView;
  Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
begin
   if secMers[item.Index].active then
      secMer.listView.Canvas.Brush.Color := s23_edit.Color
   else
      secMer.listView.Canvas.Brush.Color := s24_edit.Color;

   if item.Selected then
      secMer.listView.Canvas.Font.Style :=
      secMer.listView.Canvas.Font.Style + [fsBold];
end;

procedure Tutils_form.secMer_listDblClick(Sender: TObject);
var
c: smallInt;
begin
   if secMer.areAnySelected = 0 then exit;

   for c := 0 to high(secMers) do
     if secMers[c].selected then
     begin
        if utils_form.s3_btn.checked then secMer.showInfo(c);
        if utils_form.s4_btn.checked then secMer.edit(c);
        if utils_form.s5_btn.checked then s_delExecute(sender);
        exit;
     end;
end;

procedure Tutils_form.secMer_listSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
   secMer.listSelect(item.Index, selected);
end;

procedure Tutils_form.speakEnd(var msg: tMessage);
begin
   {allowTimeSpeak := true;
   showMessage('play end! UTILS');}
end;

procedure Tutils_form.a_menu_buttonClick(Sender: TObject);
var
p: tPoint;
begin
   getCursorPos(p);
   a_popUp.Popup(p.x, p.y);
end;

procedure Tutils_form.s_activeExecute(Sender: TObject);
var
c: smallInt;
begin
   if secMer.areAnySelected = 0 then exit;

   for c := 0 to high(secMers) do
     if secMers[c].selected then
     secMer.setActive(c, _secMeractive.Checked);

   {if al_select_index >= 0 then
      alarm.setActive(al_select_index, a_active.Checked);}
end;

procedure Tutils_form.s_addExecute(Sender: TObject);
begin
   secMer.add;
end;

procedure Tutils_form.s_allActiveExecute(Sender: TObject);
begin
   secMer.setAllActive(true);
end;

procedure Tutils_form.s_allUnActiveExecute(Sender: TObject);
begin
   secMer.setAllActive(false);
end;

procedure Tutils_form.s_menu_buttonClick(Sender: TObject);
var
p: tPoint;
begin
   getCursorPos(p);
   s_popUp.Popup(p.x, p.y);
end;

procedure Tutils_form.s_delExecute(Sender: TObject);
var
c: smallInt;
haveToDel: array of smallInt;
begin
   if secMer.areAnySelected = 0 then exit;

   if utils_form.s2_btn.Checked then
   begin
      for c := 0 to high(secMers) do
      secMers[c].editing := secMers[c].selected;

      secMer.listCreate;

      if messageDlg('Вы действительно хотите удалить выбранные секундомеры?',
       mtConfirmation, mbYesNo, 0) <> mrYes then
      begin
         for c := 0 to high(secMers) do
         secMers[c].editing := false;

         secMer.listCreate;
         exit;
      end;
   end;

   for c := 0 to high(secMers) do
   begin
      if secMers[c].selected then
      begin
         setLength(haveToDel, high(haveToDel)+2);
         haveToDel[high(haveToDel)] := c;
      end;
   end;

   for c := high(haveToDel) downto 0 do
      secMer.onlyDel(haveToDel[c]);

   secMer.selectAfterDel(sl_first_selected);
end;

procedure Tutils_form.s_del_allExecute(Sender: TObject);
begin
   if high(secMers) < 0 then exit;
   if utils_form.s2_btn.Checked then
      if messageDlg('Вы действительно хотите удалить все секундомеры?', mtConfirmation, mbYesNo, 0) <> mrYes then exit;
   secMer.delAll;
end;

procedure Tutils_form.s_editExecute(Sender: TObject);
begin
   if secMer.areAnySelected = 0 then exit;
   secMer.edit(sl_first_selected);
end;

procedure Tutils_form.s_resetExecute(Sender: TObject);
var
c: smallInt;
begin
   if secMer.areAnySelected = 0 then exit;

   for c := 0 to high(secMers) do
     if secMers[c].selected then secMer.reset(c);
end;

procedure Tutils_form.s_selectActiveExecute(Sender: TObject);
var
c: smallInt;
//multiNotPress: boolean;
begin
   if high(secMers) < 0 then exit;
   //multiNotPress := getasynckeystate(mSelectKey) = 0;
   for c := 0 to high(secMers) do
     if secMers[c].active then
       secMer.listView.Items[c].Selected := true
     else
       if not ctrlPress then secMer.listView.Items[c].Selected := false;
   try
      secMer.listView.SetFocus;
   except

   end;
end;

procedure Tutils_form.s_selectAllExecute(Sender: TObject);
var
c: smallInt;
begin
   if high(secMers) < 0 then exit;
   for c := 0 to high(secMers) do
     secMer.listView.Items[c].Selected := true;
end;

procedure Tutils_form.s_selectedActiveExecute(Sender: TObject);
var
c: smallInt;
begin
   if high(secMers) < 0 then exit;
   for c := 0 to high(secMers) do
     if secMers[c].selected then secMer.setActive(c, true);
end;

procedure Tutils_form.s_selectedUnActiveExecute(Sender: TObject);
var
c: smallInt;
begin
   if high(secMers) < 0 then exit;
   for c := 0 to high(secMers) do
     if secMers[c].selected then secMer.setActive(c, false);
end;

procedure Tutils_form.s_selectInvertExecute(Sender: TObject);
var
c: smallInt;
begin
   if high(secMers) < 0 then exit;
   for c := 0 to high(secMers) do
        secMer.listView.Items[c].Selected := not secMers[c].selected;
end;

procedure Tutils_form.s_selectUnActiveExecute(Sender: TObject);
var
c: smallInt;
//multiNotPress: boolean;
begin
   if high(secMers) < 0 then exit;
   //multiNotPress := getasynckeystate(mSelectKey) = 0;
   for c := 0 to high(secMers) do
     if not secMers[c].active then
       secMer.listView.Items[c].Selected := true
     else
       if not ctrlPress then secMer.listView.Items[c].Selected := false;
   try
      secMer.listView.SetFocus;
   except

   end;
end;

procedure Tutils_form.s_showinfoExecute(Sender: TObject);
begin
   if secMer.areAnySelected > 0 then
   secMer.showInfo(sl_first_Selected);
end;

procedure Tutils_form.timer_active_buttonClick(Sender: TObject);
var
c: smallInt;
begin
   if timer.areAnySelected = 0 then exit;

   for c := 0 to high(timers) do
     if timers[c].selected then
     timer.setActive(c, timer_active_button.down);

   {if al_select_index >= 0 then
      alarm.setActive(al_select_index, a_active.Checked);}
end;

procedure Tutils_form.timer_listCustomDrawItem(Sender: TCustomListView;
  Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
begin
   if timers[item.Index].active then
      timer.listView.Canvas.Brush.Color := s23_edit.Color
   else
      timer.listView.Canvas.Brush.Color := s24_edit.Color;

   if item.Selected then
      timer.listView.Canvas.Font.Style :=
      timer.listView.Canvas.Font.Style + [fsBold];
end;

procedure Tutils_form.timer_listDblClick(Sender: TObject);
var
c: smallInt;
begin
   if timer.areAnySelected = 0 then exit;

   for c := 0 to high(timers) do
     if timers[c].selected then
     begin
        if utils_form.s3_btn.checked then timer.showInfo(c);
        if utils_form.s4_btn.checked then timer.edit(c);
        if utils_form.s5_btn.checked then t_delExecute(sender);
        exit;
     end;
end;

procedure Tutils_form.timer_listSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
   timer.listSelect(item.Index, selected);
end;

procedure Tutils_form.t_activeExecute(Sender: TObject);
var
c: smallInt;
begin
   if timer.areAnySelected = 0 then exit;

   for c := 0 to high(timers) do
     if timers[c].selected then
     timer.setActive(c, _timeractive.Checked);

   {if al_select_index >= 0 then
      alarm.setActive(al_select_index, a_active.Checked);}
end;

procedure Tutils_form.t_addExecute(Sender: TObject);
begin
   timer.add;
end;

procedure Tutils_form.t_allActiveExecute(Sender: TObject);
begin
   timer.setAllActive(true);
end;

procedure Tutils_form.t_allUnActiveExecute(Sender: TObject);
begin
   timer.setAllActive(false);
end;

procedure Tutils_form.t_menu_buttonClick(Sender: TObject);
var
p: tPoint;
begin
   getCursorPos(p);
   t_popUp.Popup(p.x, p.y);
end;

procedure Tutils_form.t_delExecute(Sender: TObject);
var
c: smallInt;
haveToDel: array of smallInt;
begin
   if timer.areAnySelected = 0 then exit;

   if utils_form.s2_btn.Checked then
   begin
      for c := 0 to high(timers) do
      timers[c].editing := timers[c].selected;
      
      timer.listCreate;

      if messageDlg('Вы действительно хотите удалить выбранные таймеры?',
       mtConfirmation, mbYesNo, 0) <> mrYes then
      begin
         for c := 0 to high(timers) do
         timers[c].editing := false;

         timer.listCreate;
         exit;
      end;
   end;

   for c := 0 to high(timers) do
   begin
      if timers[c].selected then
      begin
         setLength(haveToDel, high(haveToDel)+2);
         haveToDel[high(haveToDel)] := c;
      end;
   end;

   for c := high(haveToDel) downto 0 do
      timer.onlyDel(haveToDel[c]);

   timer.selectAfterDel(tl_first_Selected);
end;

procedure Tutils_form.t_del_allExecute(Sender: TObject);
begin
   if high(timers) < 0 then exit;
   if utils_form.s2_btn.Checked then
      if messageDlg('Вы действительно хотите удалить все таймеры?', mtConfirmation, mbYesNo, 0) <> mrYes then exit;
   timer.delAll;
end;

procedure Tutils_form.t_editExecute(Sender: TObject);
begin
   if timer.areAnySelected = 0 then exit;
   timer.edit(tl_first_selected);
end;

procedure Tutils_form.t_resetExecute(Sender: TObject);
var
c: smallInt;
begin
   if timer.areAnySelected = 0 then exit;

   for c := 0 to high(timers) do
     if timers[c].selected then timer.reset(c);
end;

procedure Tutils_form.t_selectActiveExecute(Sender: TObject);
var
c: smallInt;
//multiNotPress: Boolean;
begin
   if high(timers) < 0 then exit;
   //multiNotPress := getasynckeystate(mSelectKey) = 0;
   for c := 0 to high(timers) do
     if timers[c].active then
       timer.listView.Items[c].Selected := true
     else
       if not ctrlPress then timer.listView.Items[c].Selected := false;
   try
      timer.listView.SetFocus;
   except

   end;
end;

procedure Tutils_form.t_selectAllExecute(Sender: TObject);
var
c: smallInt;
begin
   if high(timers) < 0 then exit;
   for c := 0 to high(timers) do
     timer.listView.Items[c].Selected := true;
end;

procedure Tutils_form.t_selectedActiveExecute(Sender: TObject);
var
c: smallInt;
begin
   if high(timers) < 0 then  exit;
   for c := 0 to high(timers) do
     if timers[c].selected then timer.setActive(c, true);
end;

procedure Tutils_form.t_selectedUnActiveExecute(Sender: TObject);
var
c: smallInt;
begin
   if high(timers) < 0 then  exit;
   for c := 0 to high(timers) do
     if timers[c].selected then timer.setActive(c, false);
end;

procedure Tutils_form.t_selectInvertExecute(Sender: TObject);
var
c: smallInt;
begin
   if high(timers) < 0 then exit;
   for c := 0 to high(timers) do
        timer.listView.Items[c].Selected := not timers[c].selected;
end;

procedure Tutils_form.t_selectUnActiveExecute(Sender: TObject);
var
c: smallInt;
//multiNotPress: Boolean;
begin
   if high(timers) < 0 then exit;
   //multiNotPress := getasynckeystate(mSelectKey) = 0;
   for c := 0 to high(timers) do
     if not timers[c].active then
       timer.listView.Items[c].Selected := true
     else
       if not ctrlPress then timer.listView.Items[c].Selected := false;
   try
      timer.listView.SetFocus;
   except

   end;
end;

procedure Tutils_form.t_showinfoExecute(Sender: TObject);
begin
   if timer.areAnySelected > 0 then
   timer.showInfo(tl_first_Selected);
end;

procedure Tutils_form._closeExecute(Sender: TObject);
begin
   if groupEdit_form.groupView.focused then
   begin
      groupEdit_form.close;
      exit;
   end;

   if calendarEdit_form.dayEdit.Focused or calendarEdit_form.calendar_mode.Focused then
   begin
      calendarEdit_form.close;
      exit;
   end;

   close;
end;

procedure Tutils_form._loadPoramitersExecute(Sender: TObject);
begin
   setLength(alarms, 0);
   setLength(groups, 0);
   setLength(timers, 0);
   setLength(secMers, 0);

   alarm.listSelect(-1, false);
   timer.listSelect(-1, false);
   secMer.listSelect(-1, false);

   alarm.loadList;
   timer.loadList;
   secMer.loadList;

   alarm.listCreate;
   timer.listCreate;
   secMer.listCreate;
end;

procedure Tutils_form._nextExecute(Sender: TObject);
begin
   if pages.ActivePageIndex < pages.PageCount - 1 then
      pages.ActivePageIndex := pages.ActivePageIndex + 1
   else
      pages.ActivePageIndex := 0;
end;

procedure Tutils_form._onEnterExecute(Sender: TObject);
begin
   if groupEdit_form.groupView.focused then
   begin
      groupEdit_form.select_button.OnClick(nil);
      exit;
   end;

   if calendarEdit_form.dayEdit.focused then
   begin
      calendarEdit_form.dayEditClick(nil);
      exit;
   end;

   case pages.ActivePageIndex of
   0: alarm_listDblClick(nil);
   1: timer_listDblClick(nil);
   2: secMer_listDblClick(nil);
   end;
end;

procedure Tutils_form._previousExecute(Sender: TObject);
begin
   if pages.ActivePageIndex > 0 then
      pages.ActivePageIndex := pages.ActivePageIndex - 1
   else
      pages.ActivePageIndex := pages.PageCount - 1;
end;

procedure Tutils_form._savePorametersExecute(Sender: TObject);
begin
   if utils_form.s31_btn.Checked then
      if messageDlg('Сохранение запрещено!'+#13#10+
      'Вы точно хотите перезаписать дазу данных?', mtWarning,
      mbYesNo, 0) <> mrYes then exit;
      
   alarm.saveList;
   timer.saveList;
   secMer.saveList;
end;

procedure Tutils_form._selectAllExecute(Sender: TObject);
begin
   if groupEdit_form.groupView.focused then
   begin
      groupEdit_form._selectAll.OnClick(nil);
      exit;
   end;

   case pages.ActivePageIndex of
   0: a_selectAllexecute(nil);
   1: t_selectAllexecute(nil);
   2: s_selectAllexecute(nil);
   end;
end;

end.
