unit soundPlay;

interface

uses
  MPlayer, forms;

type
   tPlayer = class

   private
      fPlayer: tMediaPlayer;
      fWay: string;
      fRepeatNums: byte;
      fRepeatUnlimit: boolean;

   published
      procedure mPlayerNotify(Sender: TObject);
      constructor create(const player: tMediaPlayer);
      procedure play;
      procedure stop;

      //property player: tMediaPlayer read fPlayer write fPlayer;
      property way: string read fWay write fWay;
      property repeatNums: byte read fRepeatNums write fRepeatNums;
      property RepeatUnlimit: boolean read fRepeatUnlimit write fRepeatUnlimit;
   end;

var
   _Player: tPlayer;
implementation

uses global_vars, SysUtils, Dialogs;

{ tPlayer }

constructor tPlayer.create(const player: tMediaPlayer);
begin
   //fPlayer := tMediaPlayer.Create(application);
   fPlayer := player;
   fPlayer.OnNotify := mPlayerNotify;
end;

procedure tPlayer.mPlayerNotify(Sender: TObject);
begin
   if fplayer.NotifyValue = nvSuccessful then
   if fRepeatUnlimit then fPlayer.Play
   else
   if fRepeatNums > 1 then
   begin
      fRepeatNums := fRepeatNums - 1;
      fPlayer.Play;
   end;
end;

procedure tPlayer.play;
begin
   try
      fPlayer.FileName := fWay;
      fPlayer.Open;
      fPlayer.Play;
   except

   end;
end;

procedure tPlayer.stop;
begin
   try
      fplayer.Stop;
      fplayer.Close;
   except

   end;
end;

end.
