library timeSpeak;
uses
  classes, mmSystem, dialogs,
  sysUtils,
  forms,
  timeSpeakThread in 'timeSpeakThread.pas',
  timeSpeakUnit in 'timeSpeakUnit.pas';

var
  st: tSpeakThread;

procedure sayTime(const hour, minute: word; const handle: tHandle; const user: integer); stdCall;
begin
   messageHandle := handle;
   userValue := user;

   path := extractFilePath(application.ExeName)+'_timeSpeakConst\';

   say(hour, minute);
   st := tSpeakThread.Create(true);
   st.Priority := tpHighest;
   st.FreeOnTerminate := true;
   st.Resume;
end;

procedure stopSpeaking; stdCall;
begin
   try
     st.Terminate;
   except

   end;
end;

exports sayTime, stopSpeaking;

begin
end.
